package pfc.prototipo;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.JLayeredPane;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JRootPane;

import org.apache.log4j.Logger;

import pfc.prototipo.bbdd.PFC_BDGestion;
import pfc.prototipo.jxta.PFC_JxtaID;

/**<p>Define todas las constantes utilizadas en la aplicacin referente al ambito global de la misma.</p>
 * <p>No tiene en cuenta aquellas constantes que hacen referencia a cosas particulares como pueda ser la comunicacin jxta o bbdd</p>
 * 
 * @author Angel
 *
 */

public class PFC_Constantes 
{
	//Trazas
	private final static Logger moLog = Logger.getLogger(PFC_Constantes.class);
	
	/* Gestin del aplicativo */
	
	// define el ancho de la pantalla principal
	public static int PANTALLA_ANCHO = 900;
	
	// define el alto de la pantalla principal
	public static int PANTALLA_ALTO = 800;
	
	// identifica el path donde se guardaran los documentos que maneja la solucin
	public static String DIRECTORIO = "\\documentos\\";

	// extension permitida de los documentos
	public static String DOCUMENTO_EXTENSION = ".xml";

	// Indica si la aplicacion esta conectada al grupo o esta trabajando sin conexion. Por defecto NO
	public static boolean ESTOY_CONECTADO = false;
	
	// Estado conectado
	public static String ESTADO_CONECTADO = "Connected";
	
	// Estado desconectado
	public static String ESTADO_DESCONECTADO = "Disconnected";
	
	// Estado conectando
	public static String ESTADO_CONECTANDO = "Connecting...";

	// Nombre del Panel de Estado
	public static String PANEL_ESTADO_NOMBRE = "PanelEstado";
	
	// Nombre del Label de Estado
	public static String LABEL_ESTADO_NOMBRE = "LabelEstado";

	// Nombre de la barra de progreso
	public static String PROGRESO_BARRA = "BarraProgreso";

	/* Gestin el Menu */
	public static String MENU_CONEXION = "Connection";
	public static String MENU_CONEXION_GESTION = "Manage";
	public static String MENU_FICHEROS = "Files";
	public static String MENU_FICHEROS_LISTAR = "List";
	public static String MENU_FICHEROS_NUEVO = "New";
	public static String MENU_SISTEMA = "System";
	public static String MENU_SISTEMA_CONFIGURAR = "Configure";
	public static String MENU_SISTEMA_SALIR = "Exit";
	
	/* Gestin de Nodos y Grupo de trabajo */
	
	// identifica el nombre grupo de trabajo.
	public static String GRUPO_TRABAJO_NOMBRE = "PFC_GrupoTrabajo";
	public static String GRUPO_TRABAJO_DESC = "Grupo Gestion Documentos";

	// identifica el identificador del Pipe Multicast 
	public static String PIPE_MULTICAST_ID = "";
	// identifica el nombre del Pipe Multicast 
	public static String PIPE_MULTICAST_NOMBRE = "ComunicacionGrupo";
	
	// identifica el identificador del Pipe Unicast 
	public static String PIPE_UNICAST_ID = "";
	// identifica el nombre del Pipe Uniicast 
	public static String PIPE_UNICAST_NOMBRE = "ComunicacionPeer";

	
	//Parte fija del nombre del Nodo.
	public static String NODO_NOMBRE_PREFIJO = "PFC_Nodo";
	
	//Nombre establecido al SuperPeer
	public static String SUPERPEER_NOMBRE_PREFIJO = "PFC_SuperPeer";

	//IP del SuperPeer (por defecto)
	public static String SUPERPEER_IP = "127.0.0.1";

	//Puerto del SuperPeer (por defecto)
	public static String SUPERPEER_PUERTO = "9717";

	// Timeout de espera Conexion con SuperPeer (30 segundos)
	public static int TIMEOUT_ESPERA_SUPERPEER = 30 * 1000;

	// Timeout socket Unicast (10 segundos)
	public static int TIMEOUT_SOCKET_UNICAST = 15 * 1000;
	
	// Indica si el usuario ha cambiado IP o puerto del SuperPeer lo que significa que hay que volver a cargar config
	public static boolean CAMBIO_CONFIGURACION = false;
	
	//Nombre del Nodo.
	public static String NODO_NOMBRE = "";
	//Identificador del Nodo
	public static String NODO_ID = "";
		
	/* Gestion de la base de datos */
	
	//Manejo con la base de datos
	public static String BD_DRIVER = "org.apache.derby.jdbc.EmbeddedDriver";
	//Nombre de la base de datos
	public static String BD_NOMBRE = "PFCGrupoBD";	
	//URL de conexion con la base de datos
	public static String BD_URL = "jdbc:derby:" + BD_NOMBRE + ";create=true";
		
	//Tabla de configuracion
	public static String TABLA_CONFIGURACION = "CONFIGURACION";
	
	//Tabla de documentos
	public static String TABLA_DOCUMENTOS = "DOCUMENTOS";
	
	//Configuracion: Campo Nombre del Peer
	public static String CONFIGURACION_NOMBRE_PEER = "CONF_NombrePeer";
	//Configuracion: identificador del Peer
	public static String CONFIGURACION_ID_PEER = "CONF_IdPeer";
	//Configuracion: Campo Nombre del Grupo
	public static String CONFIGURACION_NOMBRE_GRUPO = "CONF_NombreGrupo";
	//Configuracion: Campo identificador del Pipe de Grupo (Multicast)
	public static String CONFIGURACION_ID_PIPE_MULTICAST = "CONF_IdPipeMulticast";
	//Configuracion: Campo identificador del Pipe Peer (Unicast)
	public static String CONFIGURACION_ID_PIPE_UNICAST = "CONF_IdPipeUnicast";

	//Configuracion: Campo SuperPeer IP
	public static String CONFIGURACION_SUPERPEER_IP = "CONF_SuperPeerIP";
	
	//Configuracion: Campo SuperPeer Puerto
	public static String CONFIGURACION_SUPERPEER_PUERTO = "CONF_SuperPeerPuerto";

	//Configuracion: Campo directorio
	public static String CONFIGURACION_DIRECTORIO = "CONF_Directorio";

	//Configuracion: Campo Hay Cambios Aplicar
	public static String CONFIGURACION_CAMBIOS = "CONF_Cambios";	
	
	//Documentos: Longuitud campo Nombre
	public static int DOCUMENTOS_LON_NOMBRE = 30;
	
	
	/* Gestin de las ventanas de la aplicacion */

	// Nombre que se le da a la aplicacion
	public static String NOMBRE_APLICACION = "PFC - Gestin de Documentos";
	
	// Listado de documentos: Nombre de la lista
	public static String LISTA_DOCUMENTOS = "Showing documents:";
	
	// Listado de documentos: Columna nombre
	public static String LISTA_COLUMNA_DOCUMENTO = "Document";

	// Listado de documentos: Columna Fecha
	public static String LISTA_COLUMNA_FECHA = "Date";

	// Listado de documentos: Columna Propietario
	public static String LISTA_COLUMNA_PROPIETARIO = "O.";

	// Edicion del documento: Label
	public static String EDICION_LABEL = "Name:";
	
	// Boton Guardar
	public static String BOTON_GUARDAR = "Save";
	
	// Boton Eliminar
	public static String BOTON_ELIMINAR = "Delete";

	// Etiqueta Nombre Peer
	public static String ETIQUETA_NOMBRE_PEER = "Peer name:";
	// Etiqueta Id Peer
	public static String ETIQUETA_ID_PEER = "Peer ID:";
	// Etiqueta Nombre Grupo
	public static String ETIQUETA_NOMBRE_GRUPO = "Group name:";
	// Etiqueta Id Grupo
	public static String ETIQUETA_ID_GRUPO = "Group ID:";

	// Etiqueta Nombre Pipe Grupo
	public static String ETIQUETA_NOMBRE_CANAL_GRUPO = "Channel group name:";
	// Etiqueta Id Pipe Grupo
	public static String ETIQUETA_ID_CANAL_GRUPO = "Channel group ID:";

	// Etiqueta Nombre Pipe Unicast
	public static String ETIQUETA_NOMBRE_CANAL_UNICAST = "Individual channel name:";
	// Etiqueta Id Pipe Individual
	public static String ETIQUETA_ID_CANAL_UNICAST = "Individual channel ID:";
	// Etiqueta Datos del SuperPeer
	public static String ETIQUETA_DATOS_SUPERPEER = "SuperPeer:";

	
	// Etiqueta Directorio
	public static String ETIQUETA_DIRECTORIO = "Working directory:";
	// Etiqueta IP SuperPeer configurar
	public static String ETIQUETA_SUPERPEER_IP = "IP SuperPeer:";
	// Etiqueta Puerto SuperPeer configurar
	public static String ETIQUETA_SUPERPEER_PUERTO = "Port SuperPeer:";
	
	// Boton Conectar
	public static String BOTON_CONECTAR = "Connect";
	
	// Boton Desconectar
	public static String BOTON_DESCONECTAR = "Disconnect";
	
	/* Gestin titulos de pantallas */ 
	
	// Titulo Dialogo aviso falta nombre documento
	public static String TITULO_AVISO_NOMBRE_DOCUMENTO = "Save";
	// Titulo Dialogo aviso no se ha podido crear documento
	public static String TITULO_AVISO_ERROR_CREAR_DOCUMENTO = "Error - Document";
	// Titulo Dialogo aviso modificar
	public static String TITULO_AVISO_MODIFICAR_DOCUMENTO = "Change";	
	
	
	/* Gestin de los avisos */
	
	// Aviso falta introducir nombre del documento
	public static String AVISO_NOMBRE_DOCUMENTO = "Need to enter the document name!";
	// Aviso falta introducir contenido del documento
	public static String AVISO_CONTENIDO_DOCUMENTO = "Need to introduce the contents of the document!";
	// Aviso no se ha podido crear el documento
	public static String AVISO_ERROR_CREAR_DOCUMENTO = "Failed to create the document. Verify that there already exist.";
	// Aviso no se ha podido crear el documento por problemas de formato
	public static String AVISO_ERROR_CREAR_DOCUMENTO_FORMATO = "Failed to create the document.\nCheck content / format.\nCheck the working directory.";
	// Aviso no se ha podido informar al grupo del alta del documento
	public static String AVISO_ERROR_INFORMAR_GRUPO_ALTA = "Unable to send the new document Group.\n New document is stored as back-ordered. \n Disconnection of the group is made.";
	// Aviso no se ha podido informar al grupo de la baja del documento
	public static String AVISO_ERROR_INFORMAR_GRUPO_BAJA = "Unable to send the document down Group.";
	// Aviso no se ha podido informar al grupo de las modificaciones del documento
	public static String AVISO_ERROR_INFORMAR_GRUPO_MODIFICAR = "Unable to send the Group document changes.";
	// Aviso no se ha podido pedir al SuperPeer de las actualizaciones disponibles
	public static String AVISO_ERROR_PEDIR_SP_ACTUALIZACIONES = "Could not ask for available updates SuperPeer.";
	// Aviso no se ha podido enviar al grupo los cambios realizados
	public static String AVISO_ERROR_ENVIAR_MODIFICACIONES = "Unable to send the changes made to Group.";	
	// Aviso no se puede cargar fichero
	public static String AVISO_ERROR_CARGA_FICHERO = "Could not load the file.";
	// Aviso nombre documento muy grande
	public static String AVISO_ERROR_LON_NOM_DOCUMENTO = "Document Name Size very high (Max.30).";
	// Aviso nombre de documento erroneo.
	public static String AVISO_NOMBRE_ERRONEO = "The document name or extension is not correct (xxx.xml)";
	// Aviso no se ha podido modificar el documento
	public static String AVISO_ERROR_MODIFICAR_DOCUMENTO = "Unable to modify the document.\nCheck content / format.";
	// Aviso no modificacion documento ok
	public static String AVISO_OK_MODIFICAR_DOCUMENTO = "The document has been modified!";
	// Aviso no se ha podido eliminar el documento
	public static String AVISO_ERROR_ELIMINAR_DOCUMENTO = "Unable to delete the document";
	// Aviso no se ha podido dar de alta una notificacion
	public static String AVISO_ERROR_ALTA_NOTIFICACION = "Unable to enlist in the notice.";
	// Aviso no se permite modificar nombre del nodo raiz
	public static String AVISO_NO_MODIFICAR_NOMBRE_RAIZ = "Not modify the name of the root node.";

	// Aviso confirmar borrado de fichero
	public static String AVISO_CONFIRMAR_BORRAR_DOCUMENTO = "Sure you want to delete the document?";

	// Aviso directorio no valido
	public static String AVISO_DIRECTORIO_NO_VALIDO = "Invalid Directory!";
	// Aviso IP SuperPeer no valida
	public static String AVISO_SUPERPEERIP_NO_VALIDO = "No valid IP SuperPeer!";
	// Aviso puerto SuperPeer no valido
	public static String AVISO_SUPERPEERPUERTO_NO_VALIDO = "Invalid port SuperPeer!";

	// Aviso no se puede cambiar nombre directorio
	public static String AVISO_DIRECTORIO_NO_CAMBIADO = "Failed to change directory!";
	// Aviso no se puede cambiar IP del SuperPeer
	public static String AVISO_SUPERPEERIP_NO_CAMBIADO = "Unable to change the IP of SuperPeer!";
	// Aviso no se puede cambiar puerto del SuperPeer
	public static String AVISO_SUPERPEERPUERTO_NO_CAMBIADO = "Unable to change the Port of SuperPeer!";

	// Aviso ok al cambiar nombre directorio
	public static String AVISO_DIRECTORIO_OK_CAMBIADO = "Working directory changed!";
	// Aviso ok al cambiar IP del SuperPeer
	public static String AVISO_SUPERPEERIP_OK_CAMBIADO = "SuperPeer IP modified!";
	// Aviso ok al cambiar Puerto del SuperPeer
	public static String AVISO_SUPERPEERPUERTO_OK_CAMBIADO = "SuperPeer Port modified!";
	
	/* Tipologia de Notificaciones */
	public static String NOTIFICACION_ALTA = "A";
	public static String NOTIFICACION_BAJA = "B";
	public static String NOTIFICACION_MODIFICACION = "M";
	
	// Aviso error conexion peer
	public static String ERROR_CONEXION_PEER = "Peer can not connect to the network";
	// Aviso error carga configuracion peer
	public static String ERROR_CARGA_CONFIGURACION_PEER = "Peer can not load / create configuration";
	// Aviso error inicializar red
	public static String ERROR_INI_RED_PEER = "Peer network can not initialize";
	// Aviso error sin conexion con superpeer
	public static String ERROR_NO_CONEXION_SUPERPEER = "Unable to establish connection with SuperPeer";
	// Aviso error sin adhesion al grupo
	public static String ERROR_NO_CONEXION_GRUPO = "Can not be attached to the Group";
	
	
	/**
	 * <p>Compone el nombre que se le asigna al documento cuando se guarda en disco. Se compone de:</p>
	 * <p>Ruta+Nodo_ID.substring(14)+"_"+Nombre</p>
	 * @return
	 */
	public static String componeNomDocFisico(String psRuta, String psNodo, String psNombre)
	{
		return psRuta+psNodo.substring(14)+"_"+psNombre;
	}
	
	/**
	 * <p>Compone el identificador del documento. Se compone de:</p>
	 * <p>Nodo_ID.substring(14)+"_"+NombreDoc sin .xml</p>
	 * @return
	 */
	public static String componeIdDoc(String psNodo, String psNombre)
	{
		return psNodo.substring(14)+"_"+psNombre.substring(0, (psNombre.length()-4));
	}

	/**
	 * <p>Se encarga de verificar si existe el directorio donde se guardaran los documentos.</p>
	 * <p>En caso de no existir, se crea la ruta completa.</p>
	 * @param psDirectorio Ruta del directorio a crear
	 */
	public static void verificaDirectorio(String psDirectorio) throws Exception
	{
		//Una vez creada la configuracion, se verifica que el directorio de trabajo existe. En caso negativo, se crea
		File loDirectorio = new File(psDirectorio);
		
		if (!loDirectorio.exists())
		{
			moLog.info("Directorio <"+psDirectorio+"> no existe en el sistema. Se crea");
			loDirectorio.mkdirs();
			moLog.info("Directorio <"+psDirectorio+"> creado!");
		}
	}//verificaDirectorio

	/**
	 * <p>Carga la configuracion del sistema y verifica que el directorio de documentos existe.</p>
	 * @throws Exception
	 */
	public static void cargarConfiguracion(PFC_BDGestion poGestionBD) throws Exception
	{
		//Se carga configuracion de base de datos
		poGestionBD.cargaConfiguracion();
		
		//Gestion del directorio de documentos
		verificaDirectorio(PFC_Constantes.DIRECTORIO);
		
	}//cargarConfiguracion

	/**
	 * <p>Genera configuracion por no disponer de una. Situacin que se realizar la primera vez de ejecucin<p>
	 * @param poGestionBD Conexion con la base de datos
	 * @param pbSoySuperPeer Indica si se esta creando configuracion para SuperPeer
	 * @throws Exception 
	 */
	public static void crearConfiguracion(PFC_BDGestion poGestionBD, boolean pbSoySuperPeer) throws Exception
	{
		//Se obtiene identificador unico del Nodo
		PFC_Constantes.NODO_ID = PFC_JxtaID.createPeerID(PFC_Constantes.NODO_NOMBRE, PFC_Constantes.GRUPO_TRABAJO_NOMBRE).toString();
		//Se obtiene identificador Pipe Multicast
		PFC_Constantes.PIPE_MULTICAST_ID = PFC_JxtaID.createPipeID(PFC_Constantes.PIPE_MULTICAST_NOMBRE, PFC_Constantes.GRUPO_TRABAJO_NOMBRE).toString();
		//Se obtiene identificador Pipe Unicast
		PFC_Constantes.PIPE_UNICAST_ID = PFC_JxtaID.createPipeID(PFC_Constantes.PIPE_UNICAST_NOMBRE, PFC_Constantes.GRUPO_TRABAJO_NOMBRE).toString();
		
		//Se inicializa la configuracion de la solucion
		poGestionBD.inicializaSistema(PFC_Constantes.NODO_NOMBRE, PFC_Constantes.NODO_ID, PFC_Constantes.GRUPO_TRABAJO_NOMBRE, 
				PFC_Constantes.PIPE_MULTICAST_ID, PFC_Constantes.DIRECTORIO, PFC_Constantes.SUPERPEER_IP, 
				PFC_Constantes.SUPERPEER_PUERTO, PFC_Constantes.PIPE_UNICAST_ID, pbSoySuperPeer);
		
		//Gestion del directorio de documentos
		verificaDirectorio(PFC_Constantes.DIRECTORIO);
		
	}//crearConfiguracion

	/**
	 * <p>Valida que sea una IP correcta</p>
	 * @param psIP IP a validar
	 * @return
	 */
	public static boolean validarIP(String psIP)
	{
		
		// Se verifica que se haya introducido una IP
		if ( (psIP == null) || (psIP.length() == 0) )
		{
			return false;
		}
		
		// Se verifica que la IP introducida sea valida
		
		if (psIP.matches("[0-9]{1,3}[.][0-9]{1,3}[.][0-9]{1,3}[.][0-9]{1,3}"))
			return true;
		
		return false;
	}//validarIP

	/**
	 * <p>Valida que sea un Puerto valido</p>
	 * @param psPuerto Puerto a validar
	 * @return
	 */
	public static boolean validarPuerto(String psPuerto)
	{
		
		// Se verifica que se haya introducido un Puerto
		if ( (psPuerto == null) || (psPuerto.length() == 0) )
		{
			return false;
		}
		
		// Se verifica que el puerto introducido sea valido
		
		if (psPuerto.matches("[9][7][0-9][1-9]"))
			return true;
		
		return false;
	}//validarPuerto
	
	
	/**
	 * <p>A partir e un evento lanzado por una opcin del men, obtenemos el marco principal de la aplicacion</p>
	 * @param e
	 * @return
	 */
	public static PFC_PanelPrincipal getPrincialMenu(ActionEvent e)
	{
		return (PFC_PanelPrincipal)((JRootPane)((JLayeredPane)((JPanel)((JMenuBar)((JMenu)((JPopupMenu)((Component)e.getSource()).getParent()).getInvoker()).getParent()).getParent()).getParent()).getParent()).getParent();
	}

	/**
	 * <p>A partir e un evento lanzado por una boton en un panel, obtenemos el marco principal de la aplicacion</p>
	 * @param e
	 * @return
	 */
	public static PFC_PanelPrincipal getPrincial(ActionEvent e)
	{
		Component loComponente = (Component)e.getSource();
		
		while ( (loComponente != null) && (! (loComponente instanceof PFC_PanelPrincipal)) )
		{
			loComponente = loComponente.getParent();
		}
		return (PFC_PanelPrincipal)loComponente;
	}
	

}
