package pfc.prototipo;

import java.util.Vector;


/**
 * <p>Gestiona el listado de documentos disponibles</p>
 * @author Angel
 *
 */
public class PFC_Documentos 
{
	//Contenedor de documentos
	private Vector moDocumentos = null;
	//Representa un registro
	private Vector moFila = null;
	
	public PFC_Documentos()
	{
		moDocumentos = new Vector();		
	}
	
	
	public void addFila()
	{
		moFila = null;
		moFila = new Vector();
	}//addFila
	
	/**
	 * <p>Aade al registro un nuevo valor de columna</p>
	 * @param psIdDoc
	 */
	public void addElemento (Object poElemento)
	{
		moFila.add(poElemento);
	}//addIdDocumento
	
	/**
	 * <p>Aade un nuevo registro documento</p>
	 */
	public void addRegistro()
	{
		moDocumentos.add(moFila);
	}//addRegistro
	
	/**
	 * <p>Devuelve los datos a visualizar en el listado.</p>
	 * <p>En el listado se visualiza la siguiente informacin:</p>
	 * <p>	. Nombre</p>
	 * <p>	. Fecha actualizado</p>
	 * <p>	. Propietario</p>
	 * @return
	 */
	public Vector getDatosLista()
	{
		Vector loDatos = null;
		Vector loColumnas = null;
		Vector loTmp = null;
		
		 
		loDatos = new Vector();
		
		for (int i = 0; i < moDocumentos.size(); i++)
		{
			loColumnas = null;
			loColumnas = new Vector();
			loTmp = (Vector)moDocumentos.elementAt(i);
			
			//Obtenemos en primer lugar el nombre
			loColumnas.add(loTmp.elementAt(2));
			//Obtenemos en segundo lugar la fecha
			loColumnas.add(loTmp.elementAt(4));
			//Obtenemos en tercer lugar el propietario. Si el identificador del propietario es el del propio nodo, establecemos Si.
			//En caso contrario No
			loColumnas.add(esPropietario((String)loTmp.elementAt(1)));

			loDatos.add(loColumnas);
			
		}//for
		
		return loDatos;
	}//getDatosLista

	/**
	 * <p>Obtiene el nombre fisico con al ruta del documento del registro indicado</p>
	 * @param piFila
	 * @return
	 */
	public String getNombreFisicoDocumento(int piFila)
	{
		Vector loTmp = (Vector)moDocumentos.elementAt(piFila);
		return PFC_Constantes.componeNomDocFisico((String)loTmp.elementAt(3), (String)loTmp.elementAt(1), (String)loTmp.elementAt(2));
	}//getNombreDocumento
	
	/**
	 * <p>Obtiene el nombre del documento del registro indicado</p>
	 * @param piFila
	 * @return
	 */
	public String getNombreDocumento(int piFila)
	{
		Vector loTmp = (Vector)moDocumentos.elementAt(piFila);
		return (String)loTmp.elementAt(2);
	}//getNombreDocumento
	
	/**
	 * <p>Indica si el Nodo con el que se trabaja es propietario o no del documento</p>
	 * @param psIdNodo identificador del propietario (nodo) del documento
	 * @return S/N
	 */
	private String esPropietario(String psIdNodo)
	{
		String lsSN = "S";
		if (!psIdNodo.equals(PFC_Constantes.NODO_ID) )
			lsSN = "N";
		return lsSN;
	}//esPropietario
	
	/**
	 * <p>Obtiene el nombre del documento del registro indicado</p>
	 * @param piFila
	 * @return
	 */
	public String getSiPropietario(int piFila)
	{
		Vector loTmp = (Vector)moDocumentos.elementAt(piFila);
		return esPropietario((String)loTmp.elementAt(1));
	}//getSiPropietario
	
	
}
