package pfc.prototipo;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JProgressBar;

import org.apache.log4j.Logger;

import pfc.prototipo.bbdd.PFC_BDGestion;
import pfc.prototipo.jxta.PFC_JxtaUtilidades;
import pfc.prototipo.jxta.PFC_Mensaje;
import pfc.prototipo.jxta.peer.PFC_Peer;
import pfc.prototipo.rendimiento.PFC_Rendimiento;

/**
 * <p>Panel encargado de Gestionar la conexion con el grupo</p>
 * @author Angel
 *
 */
public class PFC_PanelConectarConexion extends JPanel 
{
	//Trazas
	private final static Logger moLog = Logger.getLogger(PFC_PanelConectarConexion.class);

	private JLabel moEtiquetaNombrePeer = null;    
	private JTextField moIntroduceNombrePeer = null;
	private JLabel moEtiquetaIdPeer = null;
	private JTextField moIntroduceIdPeer = null;
	private JLabel moEtiquetaNombreGrupo = null;    
	private JTextField moIntroduceNombreGrupo = null;
	private JLabel moEtiquetaNombrePipeGrupo = null;	
	private JTextField moIntroduceNombrePipeGrupo = null;	
	private JLabel moEtiquetaIdPipeGrupo = null;	
	private JTextField moIntroduceIdPipeGrupo = null;	
	private JLabel moEtiquetaNombrePipeUnicast = null;	
	private JTextField moIntroduceNombrePipeUnicast = null;	
	private JLabel moEtiquetaIdPipeUnicast = null;	
	private JTextField moIntroduceIdPipeUnicast = null;	
	private JLabel moEtiquetaSuperPeer = null;	
	private JTextField moIntroduceSuperPeer = null;	
    private JButton moBotonConectar = null;
    private JButton moBotonDesconectar = null;

    // Conexion con la base de datos
    private PFC_BDGestion moGestionBD = null;

	// Objeto para calcular tiempos (rendimiento)
	private PFC_Rendimiento moRendimiento = null;
    	
	public PFC_PanelConectarConexion(PFC_BDGestion poGestionBD)
	{	
		super(null);
		
		
		moGestionBD = poGestionBD;
		
		//Se aaden elementos necesarios en el panel
		moEtiquetaNombrePeer = new JLabel(PFC_Constantes.ETIQUETA_NOMBRE_PEER);
		moIntroduceNombrePeer = new JTextField();
		moEtiquetaIdPeer = new JLabel(PFC_Constantes.ETIQUETA_ID_PEER);
		moIntroduceIdPeer = new JTextField();
		moEtiquetaNombreGrupo = new JLabel(PFC_Constantes.ETIQUETA_NOMBRE_GRUPO);
		moIntroduceNombreGrupo = new JTextField();
		
		moEtiquetaNombrePipeGrupo = new JLabel(PFC_Constantes.ETIQUETA_NOMBRE_CANAL_GRUPO);
		moIntroduceNombrePipeGrupo = new JTextField();
		moEtiquetaIdPipeGrupo = new JLabel(PFC_Constantes.ETIQUETA_ID_CANAL_GRUPO);
		moIntroduceIdPipeGrupo = new JTextField();

		moEtiquetaNombrePipeUnicast = new JLabel(PFC_Constantes.ETIQUETA_NOMBRE_CANAL_UNICAST);
		moIntroduceNombrePipeUnicast = new JTextField();
		moEtiquetaIdPipeUnicast = new JLabel(PFC_Constantes.ETIQUETA_ID_CANAL_UNICAST);
		moIntroduceIdPipeUnicast = new JTextField();

		moEtiquetaSuperPeer = new JLabel(PFC_Constantes.ETIQUETA_DATOS_SUPERPEER);
		moIntroduceSuperPeer = new JTextField();
		
		moBotonConectar = new JButton(PFC_Constantes.BOTON_CONECTAR);
		moBotonDesconectar = new JButton(PFC_Constantes.BOTON_DESCONECTAR);
		
		//Se inicializan los TextField con la informacion pedida
		moIntroduceNombrePeer.setText(PFC_Constantes.NODO_NOMBRE);
		moIntroduceIdPeer.setText(PFC_Constantes.NODO_ID);		
		moIntroduceNombreGrupo.setText(PFC_Constantes.GRUPO_TRABAJO_NOMBRE);
		moIntroduceNombrePipeGrupo.setText(PFC_Constantes.PIPE_MULTICAST_NOMBRE);
		moIntroduceIdPipeGrupo.setText(PFC_Constantes.PIPE_MULTICAST_ID);
		moIntroduceNombrePipeUnicast.setText(PFC_Constantes.PIPE_UNICAST_NOMBRE);
		moIntroduceIdPipeUnicast.setText(PFC_Constantes.PIPE_UNICAST_ID);
		moIntroduceSuperPeer.setText(PFC_Constantes.SUPERPEER_IP+":"+PFC_Constantes.SUPERPEER_PUERTO);
		
		//Se desactivan todos los elementos de informacion ya que solo se trabaja en modo consulta
		moIntroduceNombrePeer.setEditable(false);
		moIntroduceIdPeer.setEditable(false);
		moIntroduceNombreGrupo.setEditable(false);
		moIntroduceNombrePipeGrupo.setEditable(false);
		moIntroduceIdPipeGrupo.setEditable(false);
		moIntroduceNombrePipeUnicast.setEditable(false);
		moIntroduceIdPipeUnicast.setEditable(false);
		moIntroduceSuperPeer.setEditable(false);
		
		//Se establece posicion de cada elemento
		moEtiquetaNombrePeer.setBounds( 10, 30, 150, 20 );
		moIntroduceNombrePeer.setBounds( 180, 30, 240, 20 );
		moEtiquetaIdPeer.setBounds( 10, 60, 150, 20 );
		moIntroduceIdPeer.setBounds( 180, 60, 600, 20 );
		moEtiquetaNombreGrupo.setBounds( 10, 90, 150, 20 );
		moIntroduceNombreGrupo.setBounds( 180, 90, 240, 20 );
		moEtiquetaNombrePipeGrupo.setBounds( 10, 120, 150, 20 );
		moIntroduceNombrePipeGrupo.setBounds( 180, 120, 600, 20 );
		moEtiquetaIdPipeGrupo.setBounds( 10, 150, 150, 20 );
		moIntroduceIdPipeGrupo.setBounds( 180, 150, 600, 20 );
		moEtiquetaNombrePipeUnicast.setBounds( 10, 180, 150, 20 );
		moIntroduceNombrePipeUnicast.setBounds( 180, 180, 600, 20 );
		moEtiquetaIdPipeUnicast.setBounds( 10, 210, 180, 20 );
		moIntroduceIdPipeUnicast.setBounds( 180, 210, 600, 20 );
		moEtiquetaSuperPeer.setBounds( 10, 240, 180, 20 );
		moIntroduceSuperPeer.setBounds( 180, 240, 240, 20 );

		moBotonConectar.setBounds( 470, 270, 120, 25 );
		moBotonDesconectar.setBounds( 620, 270, 120, 25 );

		// Si la aplicacion esta conectada al grupo, se desactiva boton conectar y unicamente se podra desconectar
		if (PFC_Constantes.ESTOY_CONECTADO)
		{
			moLog.info("Aplicacion conectada al grupo. Se deshabilita boton Conectar");
			moBotonConectar.setEnabled(false);
			moBotonDesconectar.setEnabled(true);
		}
		else
		{
			moLog.info("Aplicacion desconectada al grupo. Se deshabilita boton Desconectar");
			moBotonConectar.setEnabled(true);
			moBotonDesconectar.setEnabled(false);			
		}
		
		
		// Se aaden eventos a los botones
		moBotonConectar.addActionListener(new PFC_ConectarAccion());
		moBotonDesconectar.addActionListener(new PFC_DesconectarAccion());
		
		//Se aaden elementos al panel		
		add(moEtiquetaNombrePeer);
		add(moIntroduceNombrePeer);
		add(moEtiquetaIdPeer);
		add(moIntroduceIdPeer);
		add(moEtiquetaNombreGrupo);
		add(moIntroduceNombreGrupo);
		add(moEtiquetaNombrePipeGrupo);
		add(moIntroduceNombrePipeGrupo);
		add(moEtiquetaIdPipeGrupo);
		add(moIntroduceIdPipeGrupo);
		add(moEtiquetaNombrePipeUnicast);
		add(moIntroduceNombrePipeUnicast);
		add(moEtiquetaIdPipeUnicast);
		add(moIntroduceIdPipeUnicast);
		add(moEtiquetaSuperPeer);
		add(moIntroduceSuperPeer);
		
		add(moBotonConectar);
		add(moBotonDesconectar);
		
		// Se inicializa medidor del rendimiento
		moRendimiento = new PFC_Rendimiento();		
		
	}//	PFC_PanelConectarConexion

	/**
	 * <p>Accion del boton Conectar</p>
	 * @author angel
	 *
	 */
	public class PFC_ConectarAccion implements ActionListener
	{
		/**
		 * <p>Acccion del boton Conectar. Inicia el proceso de conexion con el grupo y sincronizacion de informacion</p>
		 */
		public void actionPerformed(ActionEvent e) 
		{
			PFC_Peer loPeer = null;
			
			moLog.info("Peticion de conexion del Nodo<"+PFC_Constantes.NODO_NOMBRE+" al grupo<"+PFC_Constantes.GRUPO_TRABAJO_NOMBRE+">");
			
			PFC_Lanzadera loLanzadera = new PFC_Lanzadera(e, this);
			Thread loThread = new Thread(loLanzadera);
			loThread.start();			
		}//actionPerformed

		/**
		 * <p>Funcion puente que permite cambiar el progreso de la barra de estado</p>
		 * @param piProgreso
		 */
		public void cambiarProgreso(int piProgreso)
		{
			try
			{
				cambiarProgreso2(piProgreso);
			}catch(Exception e)
			{
				e.printStackTrace();
			}
		}//cambiarProgreso
	}//class PFC_ConectarAccion
	
	/**
	 * <p>Accion del boton Desconectar</p>
	 * @author angel
	 *
	 */
	class PFC_DesconectarAccion implements ActionListener
	{
		/**
		 * <p>Para la conexion con la red de peer (Grupo) y reestablece los valores para saber que est en modo desconexin.</p>
		 */
		public void actionPerformed(ActionEvent e) 
		{
			// Se paran las comunicaciones con la red
			PFC_Constantes.getPrincial(e).pararComunicaciones();
			PFC_Constantes.getPrincial(e).setComunicaciones(null);

			//Se indica que la aplicacion est conectada a la red del grupo
			PFC_Constantes.ESTOY_CONECTADO = false;		
			cambiarNotificacionEstado(PFC_Constantes.ESTADO_DESCONECTADO);

			// Se deshabilita el boton Desconectar y habilita el Conectar
			moBotonDesconectar.setEnabled(false);
			moBotonConectar.setEnabled(true);
		}
	}//class PFC_DesconectarAccion

	/**
	 * <p>Cambia el literal del estado de la aplicacion. Conectado/Desconectado al Grupo</p>
	 * @param psEstado Literal con el estado
	 */
	public void cambiarNotificacionEstado(String psEstado)
	{
		Component loCom[] = ((JPanel)this.getParent()).getComponents();
		
		for (int i=0; i < loCom.length; i++)
		{
			if ( (loCom[i].getName() != null) && (loCom[i].getName().equals(PFC_Constantes.PANEL_ESTADO_NOMBRE)) )
			{
				((JLabel)((JPanel)loCom[i]).getComponent(0)).setText(psEstado);
			}
		}
	}//cambiarNotificacionEstado
	
	/**
	 * <p>Cambia el progreso de la barra de estado</p>
	 * @param piProgreso Porcentaje de avance
	 */
	public  void cambiarProgreso2(int piProgreso)
	{
		Component loCom[] = ((JPanel)this.getParent()).getComponents();
		
		for (int i=0; i < loCom.length; i++)
		{
			if ( (loCom[i].getName() != null) && (loCom[i].getName().equals(PFC_Constantes.PANEL_ESTADO_NOMBRE)) )
			{				
				((JProgressBar)((JPanel)loCom[i]).getComponent(1)).setValue(piProgreso);
				((JProgressBar)((JPanel)loCom[i]).getComponent(1)).repaint();
			}
		}
	}//cambiarProgreso

	/**
	 * <p>Activa (muestra) o desactiva (no muestra) la barra de progreso en el proceso de conexion</p>
	 * @param pbEstado
	 */
	public  void activarBarra(boolean pbEstado)
	{
		Component loCom[] = ((JPanel)this.getParent()).getComponents();
		
		for (int i=0; i < loCom.length; i++)
		{
			if ( (loCom[i].getName() != null) && (loCom[i].getName().equals(PFC_Constantes.PANEL_ESTADO_NOMBRE)) )
			{				
				((JProgressBar)((JPanel)loCom[i]).getComponent(1)).setVisible(pbEstado);				
			}
		}
	}//cambiarProgreso

	/**
	 * <p>Thread utilizado para iniciar el Peer</p>
	 * <p>Permite informar al usuario del avance de la conexion</p>
	 * @author angel
	 *
	 */
	public class PFC_Lanzadera implements Runnable
	{
		private ActionEvent moEvento = null;
		private PFC_ConectarAccion moPanel = null;

		public PFC_Lanzadera(ActionEvent e, PFC_ConectarAccion poPanel)
		{
			moEvento = e;
			moPanel = poPanel;
		}
		
		public void run() 
		{
			PFC_Peer loPeer = null;
			
			moLog.info("Peticion de conexion del Nodo<"+PFC_Constantes.NODO_NOMBRE+" al grupo<"+PFC_Constantes.GRUPO_TRABAJO_NOMBRE+">");
			
    		//Se inicializa tiempos de la operacion
    		moRendimiento.ini("Conectar");
			
			activarBarra(true);
			cambiarNotificacionEstado(PFC_Constantes.ESTADO_CONECTANDO);
			// Se realiza la conexion al grupo de trabajo
			try 
			{
				loPeer = new PFC_Peer(moGestionBD, moPanel);
			} catch (Exception e1) 
			{
				JOptionPane.showMessageDialog(((Component)((Component)moEvento.getSource()).getParent()), e1.getMessage());
				activarBarra(false);
				cambiarNotificacionEstado(PFC_Constantes.ESTADO_DESCONECTADO);
				return;
			}
			loPeer.ejecutaServicio();

			// Indicador avance del proceso
			cambiarProgreso2(65);

			PFC_Constantes.getPrincial(moEvento).setComunicaciones(loPeer);
			

			// Pedir los cambios que se hayan podido realizar en otros documentos
    		try 
    		{					    			
    			moLog.debug("Se inicia proceso para pedir los cambios realizados en el resto de componentes del Grupo");
    			//Se contruye mensaje global a enviar al SuperPeer
    			PFC_Mensaje loMensaje = new PFC_Mensaje(PFC_Constantes.NODO_ID, PFC_Mensaje.TIPO_PETICION_ACTUALIZACION);
    			//Se indica los documentos existente en el nodo
    			loMensaje.setDocumentos(moGestionBD.obtenerMisNoDocumentos(PFC_Constantes.NODO_ID));
    			
				// Se envia mensaje al SuperPeer
				loPeer.enviarMensaje(loMensaje, null);
				moLog.debug("Proceso para pedir los cambios realizados en el resto de componentes del Grupo REALIZADO");
										
			} catch (Exception e1) 
			{
				moLog.error("No se ha podido pedir a SuperPeer las actualizaciones disponibles:"+e1);
        		JOptionPane.showMessageDialog(((JPanel)((JButton)moEvento.getSource()).getParent()), PFC_Constantes.AVISO_ERROR_PEDIR_SP_ACTUALIZACIONES);
			}

			cambiarProgreso2(85);			
			
			// Se envian los cambios que se hayan podido realizar mientras estaba desconectado
    		try 
    		{					    			
    			//Se contruye mensaje global a enviar al Grupo del tipo Envio_Actualizaciones
    			PFC_Mensaje loEnvio = new PFC_Mensaje(PFC_Constantes.NODO_ID, PFC_Mensaje.TIPO_ENVIO_ACTUALIZACIONES);
    			
    			//Se obtienen las altas que se hayan podido realizar
    			Vector loDatos = moGestionBD.obtenerCambiosAlta();
    			PFC_Mensaje loMensaje = null;
    			String[] lvsDatos = null;
    			// se recorren las altas y se da de alta en el mensaje
    			for (int i=0; i < loDatos.size(); i++)
    			{
					// Devuelve un String[4] con: [0]=iddoc, [1]=nombre, [2]=ruta, [3]=fecha
    				lvsDatos = (String [])loDatos.elementAt(i);
    				// Sub-mensaje con el cambio alta
    				loMensaje = new PFC_Mensaje(PFC_Constantes.NODO_ID, PFC_Mensaje.TIPO_NUEVO);
					// Se establece el nombre del document
					loMensaje.setNombreDocumento(lvsDatos[1]);
					// Se establece el identificador del document
					loMensaje.setIdDocumento(lvsDatos[0]);		
					//Se establece la fecha del documento
					loMensaje.setFechaDocumento(PFC_JxtaUtilidades.obtenerFecha(lvsDatos[3]));
					// Se establece el propietario
					loMensaje.setPropietario(PFC_Constantes.NODO_ID);					
					// Se establece el contenido del documento
					String lsNomFisico = PFC_Constantes.componeNomDocFisico(lvsDatos[2], PFC_Constantes.NODO_ID, lvsDatos[1]);
					loMensaje.setContenido(PFC_ManejoFicheros.getFicheroByteArray(lsNomFisico));  
    				
					loEnvio.addActualizacion(loMensaje);
    			}

    			cambiarProgreso2(90);
    			
    			// Obtener las bajas
    			loDatos = moGestionBD.obtenerCambiosBaja();
    			loMensaje = null;
    			lvsDatos = null;
    			// se recorren las bajas y se da de alta en el mensaje
    			for (int i=0; i < loDatos.size(); i++)
    			{
					// Devuelve un String[1] con: [0]=iddoc
    				lvsDatos = (String [])loDatos.elementAt(i);
    				// Sub-mensaje con el cambio baja
    				loMensaje = new PFC_Mensaje(PFC_Constantes.NODO_ID, PFC_Mensaje.TIPO_BAJA);
					// Se establece el identificador del document
					loMensaje.setIdDocumento(lvsDatos[0]);		
    				
					loEnvio.addActualizacion(loMensaje);
    			}
    			
    			// Se obtienen todos los cambios que se hayan podido realizar mientras ha estado desconectado
    			Hashtable loDocs = moGestionBD.obtenerCambiosDocs();    			    			
    			Enumeration loCambios = loDocs.keys();
    			
    			while (loCambios.hasMoreElements())
    			{
    				// La key es el identificador de documento
    				String lsIdDoc = (String)loCambios.nextElement();    				
    				loMensaje = new PFC_Mensaje(PFC_Mensaje.TIPO_CAMBIO);
    				// Propietario del documento
    				loMensaje.setPeerOrigen(PFC_Constantes.NODO_ID);
    				// Se establece el identificador del document
    				loMensaje.setIdDocumento(lsIdDoc);		
    				//Se establece la fecha del documento
    				Object[] loValores = moGestionBD.obtenerDocumento(lsIdDoc);
    				loMensaje.setFechaDocumento(new java.sql.Date((Long)loValores[2]));						
    				// Se establecen los cambios realizados
    				loMensaje.setCambio((Vector)loDocs.get(lsIdDoc)); 
    				loEnvio.addActualizacion(loMensaje);    				
    			}//while
    			
    			
    			// Se informa al Grupo de las modificaciones
				loPeer.enviarMensajeGrupo(loEnvio);
				
				// Una vez enviado al grupo, se dan de baja en base de datos todos los cambios ya que se han informado al Grupo
				moGestionBD.eliminarCambios(null);
				
			} catch (Exception e1) 
			{
				moLog.error("No se ha podido enviar a SuperPeer los cambios realizados:"+e1);
        		JOptionPane.showMessageDialog(((JPanel)((JButton)moEvento.getSource()).getParent()), PFC_Constantes.AVISO_ERROR_ENVIAR_MODIFICACIONES);
        		cambiarNotificacionEstado(PFC_Constantes.ESTADO_DESCONECTADO);
        		activarBarra(false);
        		return;
			}
			
			cambiarProgreso2(100);
			//Se indica que la aplicacion est conectada a la red del grupo
			PFC_Constantes.ESTOY_CONECTADO = true;
			cambiarNotificacionEstado(PFC_Constantes.ESTADO_CONECTADO);
			// Se habilita el boton Desconectar y deshabilita el Conectar
			moBotonDesconectar.setEnabled(true);
			moBotonConectar.setEnabled(false);
			activarBarra(false);
			
			//Calculo del tiempo utilizado en dar de alta un documento.
			moRendimiento.tiempo();			
		}//run
		
	}//PFC_Lanzadera
}
